%define dhcp4ver 12:4.0.0-4
%define dhcp6ver 1.0.7-1
%define libnlver 1.0-0.15.pre8.git20071218

%define majorver 1.99
%define microver 8

Summary: A library for network interface configuration with DHCP
Name:    libdhcp
Version: %{majorver}.%{microver}
Release: 1%{?dist}
License: GPLv2+
Group:   Development/Libraries
URL:     http://dcantrel.fedorapeople.org/%{name}

Source:  http://dcantrel.fedorapeople.org/%{name}/%{name}-%{version}.tar.bz2

BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: dhcp-devel >= %{dhcp4ver}
BuildRequires: libdhcp4client-devel >= %{dhcp4ver}
BuildRequires: libdhcp6client-devel >= %{dhcp6ver}
BuildRequires: libnl-devel >= %{libnlver}
BuildRequires: pkgconfig

%description
libdhcp provides a central control library for network interface configuration
by dynamic and static methods.  Interfaces can be configured by DHCP via the
libdhcp4client library, DHCPv6 by the libdhcp6client library, or statically
by calling the appropriate libdhcp functions.

The name of the library refers to the original purpose of the library, namely
to replace libpump which did IPv4 DHCP and static network configuration.

%package devel
Summary:  C header files for development with libdhcp
Group:    Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: libdhcp4client-devel >= %{dhcp4ver}
Requires: libdhcp6client-devel >= %{dhcp6ver}
Requires: libnl-devel >= %{libnlver}

%description devel
C header files for development with libdhcp.

%prep
%setup -q

%build
%configure
%{__make} %{?_smp_mflags}

%install
%{__make} install DESTDIR=%{buildroot}
%{__rm} -f %{buildroot}%{_libdir}/libdhcp.a
%{__rm} -f %{buildroot}%{_libdir}/libdhcp.la

%clean
%{__rm} -rf %{buildroot}

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files
%defattr(-,root,root,-)
%doc README COPYING ChangeLog TODO
%{_libdir}/libdhcp-%{majorver}.so.*

%files devel
%defattr(-,root,root,-)
%{_libdir}/libdhcp.so
%{_includedir}/libdhcp
%{_libdir}/pkgconfig/libdhcp.pc

%changelog
* Mon Apr 21 2008 David Cantrell <dcantrell@redhat.com> - 1.99.8-1
- Allow single network stack manual configuration information (#230949)

* Fri Feb 08 2008 David Cantrell <dcantrell@redhat.com> - 1.99.7-2
- Rebuild for gcc-4.3

* Wed Jan 23 2008 David Cantrell <dcantrell@redhat.com> - 1.99.7-1
- Handle re-adding existing routing table entries correctly (#429763)

* Wed Jan 16 2008 David Cantrell <dcantrell@redhat.com> - 1.99.6-2
- Rebuild for new dhcpv6 and dhcp

* Mon Jan 14 2008 David Cantrell <dcantrell@redhat.com> - 1.99.6-1
- Upgrade to libdhcp-1.99.6, fixes SIGABRT problems on x86_64 (#428511)

* Mon Jan 14 2008 David Cantrell <dcantrell@redhat.com> - 1.99.5-2
- Rebuild against dhcp-4.0.0

* Thu Jan 10 2008 David Cantrell <dcantrell@redhat.com> - 1.99.5-1
- Prevent SIGABRT (#378641)

* Thu Jan 03 2008 David Cantrell <dcantrell@redhat.com> - 1.99.4-1
- Upgrade to libdhcp-1.99.4, fixes problems due to libnl API change
- Drop the libdhcp-static package

* Wed Dec 19 2007 David Cantrell <dcantrell@redhat.com> - 1.99.3-1
- Upgrade to libdhcp-1.99.3
- Rebuild for new libnl

* Fri Nov 30 2007 David Cantrell <dcantrell@redhat.com> - 1.99.1-1
- Upgrade to libdhcp-1.99.1

* Fri Nov 09 2007 David Cantrell <dcantrell@redhat.com> - 1.99.0-2
- Rebuild for new upstream release of dhcpv6

* Fri Oct 26 2007 David Cantrell <dcantrell@redhat.com> - 1.99.0-1
- Upgrade to libdhcp-1.99.0

* Tue Oct 23 2007 David Cantrell <dcantrell@redhat.com> - 1.27-4
- Patch include paths for isc_dhcp headers
- Require newer dhcp packages

* Wed Sep 19 2007 David Cantrell <dcantrell@redhat.com> - 1.27-3
- static package Requires libdhcp6client-static

* Tue Aug 21 2007 David Cantrell <dcantrell@redhat.com> - 1.27-2
- Rebuild

* Sun Aug 12 2007 David Cantrell <dcantrell@redhat.com> - 1.27-1
- Add missing libdhcp.pc to release archive

* Fri Aug 10 2007 David Cantrell <dcantrell@redhat.com> - 1.26-1
- Update license tag to indicate GPL v2 or later
- Update URLs to point to new upstream location

* Wed Aug 08 2007 David Cantrell <dcantrell@redhat.com> - 1.25-4
- Update License tag to GPLv2

* Thu Jul 12 2007 Jesse Keating <jkeating@redhat.com> - 1.25-3
- Rebuild against new dhcp packages, again

* Tue Jul 10 2007 David Cantrell <dcantrell@redhat.com> - 1.25-2
- Rebuild against new dhcp packages

* Tue Jun 12 2007 David Cantrell <dcantrell@redhat.com> - 1.25-1
- Add root-path to the list of DHCP options request (needed for stateless)

* Fri Apr 20 2007 David Cantrell <dcantrell@redhat.com> - 1.24-4
- Rename -devel-static package to -static

* Thu Apr 12 2007 David Cantrell <dcantrell@redhat.com> - 1.24-3
- Put libdhcp.a in the libdhcp-devel-static package

* Wed Apr 11 2007 David Cantrell <dcantrell@redhat.com> - 1.24-2
- Request and handle static-routes option for IPv4 requests (#149736)

* Fri Mar 23 2007 David Cantrell <dcantrell@redhat.com> - 1.24-1
- In pumpSetupInterface(), handle dual stack networks rather than defaulting
  to the value of the 'ip' structure member (#232690)

* Mon Mar 05 2007 David Cantrell <dcantrell@redhat.com> - 1.23-1
- Pass %%{_libdir} in %%install

* Mon Mar 05 2007 David Cantrell <dcantrell@redhat.com> - 1.22-1
- Remove unused variables from nic.c

* Mon Mar 05 2007 David Cantrell <dcantrell@redhat.com> - 1.21-1
- Spec file cleanups for Fedora packaging guidelines
- Lose some of the NIC_DEBUG noise (#199481)

* Fri Feb 16 2007 David Cantrell <dcantrell@redhat.com> - 1.20-2
- Rebuild for new libdhcp6client

* Fri Feb 16 2007 David Cantrell <dcantrell@redhat.com> - 1.20-1
- Make sure network interface is enabled in pumpSetupInterface (#224072)

* Thu Feb 08 2007 David Cantrell <dcantrell@redhat.com> - 1.19-5
- Rebuild for new libdhcp4client and new libdhcp6client

* Fri Feb 02 2007 David Cantrell <dcantrell@redhat.com> - 1.19-4
- Rebuild for new libdhcp4client

* Tue Jan 30 2007 David Cantrell <dcantrell@redhat.com> - 1.19-3
- Rebuild

* Mon Jan 29 2007 David Cantrell <dcantrell@redhat.com> - 1.19-2
- Rebuild for new libdhcp4client

* Fri Jan 12 2007 David Cantrell <dcantrell@redhat.com> - 1.19-1
- Catch return value of asprintf() in ifxDHCPv6() and ifxDHCPv4()

* Thu Jan 11 2007 David Cantrell <dcantrell@redhat.com> - 1.18-1
- Set IFF_UP and IFF_RUNNING flags on interface before trying to get a
  DHCP lease.  Fixes a problem with DHCP failing in anaconda using
  2.6.19 and higher kernels (#221392).

* Fri Oct 27 2006 David Cantrell <dcantrell@redhat.com> - 1.17-1
- Replace enum dhcp_state_e in libdhcp.h with the actual typedef

* Fri Oct 20 2006 David Cantrell <dcantrell@redhat.com> - 1.16-1
- Fix search_list dynamic allocation (#201907)

* Mon Oct 16 2006 Jeremy Katz <katzj@redhat.com> - 1.15-1
- fix build failure due to NULL changes 

* Fri Oct 13 2006 David Cantrell <dcantrell@redhat.com> - 1.14-1
- Archive is now a .tar.bz2

* Fri Oct 13 2006 David Cantrell <dcantrell@redhat.com> - 1.13-1
- Use NULL for pointer initialization rather than 0
- Code readability cleanups
- Do not generate Doxygen docs or examples subdir for each build, which
  corrects the multilib RPM conflicts (#210574).

* Mon Aug 14 2006 Peter Jones <pjones@redhat.com> - 1.12-1
- Fixes for ppc and ppc64 (#201920)

* Fri Aug 11 2006 David Cantrell <dcantrell@redhat.com> - 1.11-1
- If interface is already configured, down it before reconfig (#202208)

* Wed Aug 02 2006 David Cantrell <dcantrell@redhat.com> - 1.10-1
- Make the README file a little more readable
- Set char pointers to NULL after free() in dhcpv4_control_free()
- In dhcp4_nic_callback(), set state string for DHC_TIMEDOUT
- In dhcp6_nic_callback(), set state string for DHC_TIMEDOUT
- Don't free null pointers in dhcp_nic_va()

* Thu Jul 13 2006 David Cantrell <dcantrell@redhat.com> - 1.9-1
- Added IP_STRLEN() macro to ip_addr.h
- In pumpSetupInterface(), removed return_ok, make close/free calls as
  needed
- Close and free nic stuff in the right order in pumpSetupInterface()
- Removed unnecessary relinquish_timeout() calls in pumpSetupInterface()

* Wed Jul 12 2006 David Cantrell <dcantrell@redhat.com> - 1.8-1
- Removed nic_configure_resolver() and calls to it

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 1.7-1.1
- rebuild

* Tue Jul 11 2006 David Cantrell <dcantrell@redhat.com> - 1.7-1
- Poll nic_get_links() until NLMSG_DONE is received (#197172)

* Wed Jun 28 2006 Peter Jones <pjones@redhat.com> - 1.6-1
- fix two memory leaks in dhcpv4_control_va
- fix memory leaks in dhcp_nic_va
- don't fork threads if we're not using a particular protocol
- fix client finished detection logic
- add a destructor for a dhc6ctl
- relinquish timeouts when pump is finished getting a lease

* Wed Jun 21 2006 Jeremy Katz <katzj@redhat.com> - 1.5-2
- actually follow the timeout given instead of always using 10 seconds

* Thu Jun 15 2006 Peter Jones <pjones@redhat.com> - 1.5-1
- fix some bugs anaconda was hitting

* Thu Jun 08 2006 Jason Vas Dias <jvdias@redhat.com> - 1.3-1
- Ensure IPv6 module is loaded before invoking dhcpv6_client 
- fix segfault on free() of uninitialized 'sdns' in dhcp_nic

* Wed Jun 07 2006 Jason Vas Dias <jvdias@redhat.com> - 1.2-2
- fix bug 194377: -devel package missing Require:s. 

* Sun May 21 2006 Jason Vas Dias <jvdias@redhat.com> - 1.2-1
- numerous improvements - stopped using libnl cache at all to
  fix memory leaks.

* Sun May 14 2006 Jason Vas Dias <jvdias@redhat.com> - 1.1-1 
- Initial build.
